SystemOrganization addCategory: #'Orange-Xtreams'!
SystemOrganization addCategory: #'Orange-Xtreams-Tests'!

TestCase subclass: #PEGArithmeticEvaluatorTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams-Tests'!

!PEGArithmeticEvaluatorTest commentStamp: '<historical>' prior: 0!
A terminal here is an OrderedCollection that does not contain another OrderedCollection. A terminal's contents is chars or strings. In the #grammarWiki that could be: 

Bold <- "*" Flow{"*"}

Angle brackets (i.e. {}) show that something is optional. To create a bold word you need an asterisk befor a or line. It will not contain any further OrderedCollections.  !

!PEGArithmeticEvaluatorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:10'!
setUp
	| grammar |
	grammar := '
               Number                <- [0-9]+
               Parenthesised      <- "(" Expr ")"
               Value                   <- Number / Parenthesised
               Product                <- Value (("*" / "/") Value)*
               Sum                     <- Product (("+" / "-") Product)*
               Expr                     <- Sum
                '.
	parser := PEGParser parserPEG parse: 'Grammar' stream: grammar actor: PEGParserParser new.
	
	! !

!PEGArithmeticEvaluatorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:40'!
testExpr
	| result |
	result := parser parse: 'Expr' stream: '((3+4)*2-4)/2' actor: PEGArithmeticEvaluator new.
	self assert: ( 5 = result )! !

!PEGArithmeticEvaluatorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:41'!
testNumber
	| result |
	result := parser parse: 'Number' stream: '3456' actor: PEGArithmeticEvaluator new.
	self assert: (3456 = result )! !

!PEGArithmeticEvaluatorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:41'!
testParenthesized
	| result |
	result := parser parse: 'Parenthesised' stream: '(4*5)' actor: PEGArithmeticEvaluator new.
	self assert: ( 20 = result )! !

!PEGArithmeticEvaluatorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:41'!
testProduct
	| result |
	result := parser parse: 'Product' stream: '3*4*5*6' actor: PEGArithmeticEvaluator new.
	self assert: (360 = result )! !

!PEGArithmeticEvaluatorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:41'!
testSum
	| result |
	result := parser parse: 'Sum' stream: '4+5' actor: PEGArithmeticEvaluator new.
	self assert: (9 = result )! !

TestCase subclass: #PEGWikiGeneratorTest
	instanceVariableNames: 'flow parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams-Tests'!

!PEGWikiGeneratorTest commentStamp: 'chc 7/22/2015 15:10' prior: 0!
A terminal here is an OrderedCollection that does not contain another OrderedCollection. A terminal's contents is chars or strings. In the #grammarWiki that could be: 

Bold <- "*" Flow{"*"}

Angle brackets (i.e. {}) show that something is optional. To create a bold word you need an asterisk befor a or line. It will not contain any further OrderedCollections.  !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:26'!
setUp
	| grammar |
	grammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: grammar actor: PEGParserParser new.
	! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:30'!
testBold
	| result |
	result := parser parse: 'Bold' stream: '*Taco Bell*' actor: PEGWikiGenerator new.
	self assert: ( '<bold>Taco Bell</bold>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:44'!
testHeading1
	| result |
	result := parser parse: 'Heading1' stream: '  = BigDay =
				' actor: PEGWikiGenerator new.
	self assert: ( '<h1>BigDay</h1>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:45'!
testHeading2
	| result |
	result := parser parse: 'Heading2' stream: '  == BigDay ==
				' actor: PEGWikiGenerator new.
	self assert: ( '<h2>BigDay</h2>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:46'!
testHeading3
	| result |
	result := parser parse: 'Heading3' stream: '  === BigDay ===
				' actor: PEGWikiGenerator new.
	self assert: ( '<h3>BigDay</h3>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:46'!
testHeading4
	| result |
	result := parser parse: 'Heading4' stream: '  ==== BigDay ====
				' actor: PEGWikiGenerator new.
	self assert: ( '<h4>BigDay</h4>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:32'!
testItalic
	| result |
	result := parser parse: 'Italic' stream: '_Taco Bell_' actor: PEGWikiGenerator new.
	self assert: ( '<italic>Taco Bell</italic>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:34'!
testLink
	| result |
	result := parser parse: 'LinkShort' stream: '[abc]' actor: PEGWikiGenerator new.
	self assert: ( '<a href="http://www.abc.com">abc</a>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:49'!
testPage
	| result |
	result := parser parse: 'Page' stream: 'Taco Bell' actor: PEGWikiGenerator new.
	self assert: ( '<div><p>Taco Bell</p></div>' = result )! !

!PEGWikiGeneratorTest methodsFor: 'as yet unclassified' stamp: 'chc 7/28/2015 15:50'!
testParagraph
	| result |
	result := parser parse: 'Page' stream: 'Taco Bell' actor: PEGWikiGenerator new.
	self assert: ( '<div><p>Taco Bell</p></div>' = result )! !

PEGActor subclass: #PEGArithmeticEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:09'!
Number: digits
                <action: 'Number'>
                ^digits inject: 0 into: [ :total :digit | total * 10 + ('0123456789' indexOf: digit) - 1 ]! !

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:36'!
Parenthesised: expression
        <action: 'Parenthesised' arguments: #(2)>
        ^expression! !

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:27'!
Product: first rest: pairs
                <action: 'Product' arguments: #(1 2)>
                ^pairs inject: first into: [ :total :pair |
                        (pair first = '*')
                                ifTrue: [ total * pair last ]
                                ifFalse: [ total / pair last ] ]! !

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:33'!
Sum: first rest: pairs
                <action: 'Sum' arguments: #(1 2)>
                ^pairs inject: first into: [ :total :pair |
                        (pair first = '+')
                                ifTrue: [ total + pair last ]
                                ifFalse: [ total - pair last ] ]! !

PEGActor subclass: #PEGWikiGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/22/2015 14:42'!
Bold: flow
	<action: 'Bold' arguments: #( 2 )>
	^'<bold>' , (self doGenerate: flow) , '</bold>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/28/2015 15:42'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self doGenerate: flow) , '</h1>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/28/2015 15:43'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self doGenerate: flow) , '</h2>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/15/2015 14:00'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self doGenerate: flow) , '</h3>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/28/2015 15:44'!
Heading4: flow
	<action: 'Heading4' arguments: #(3) >
	^'<h4>' , (self doGenerate: flow) , '</h4>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/14/2015 14:27'!
Italic: flow
	<action: 'Italic' arguments: #( 2 )>
	^'<italic>' , (self doGenerate: flow)  ,  '</italic>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/15/2015 22:31'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| linkContent |
	linkContent := self doGenerate: flow.
	^'<a href="http://www.' , linkContent , '.com">' , linkContent , '</a>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/22/2015 15:13'!
ListItem: bullets flow: flow
	<action: 'Bullet1' arguments: #(2 3)>
	^'<li>' , (self doGenerate: flow) , '</li>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/14/2015 14:29'!
Page: lines
	<action: 'Page'>
	^'<div>' , (self doGenerate: lines) , '</div>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/14/2015 14:29'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self doGenerate: flow) , '</p>'! !

!PEGWikiGenerator methodsFor: 'private' stamp: 'chc 7/14/2015 14:35'!
doGenerate: flow
	| alltogether |
	alltogether := String new writing.
	flow do: [:ea| alltogether write: ea].
	^alltogether conclusion! !
